/* Declaration */
PImage imgBg;
PImage imgDonkey;
PImage imgMarioL;  //Mario左
PImage imgMarioR;  //Mario右
PImage imgMon1;
float  fX; //Mario X
float  fY; //Mario Y
int    iUpCtrl;  //防止連續跳/給mario爬樓梯  0可以跳/爬, 1唔可以跳
int    iDownCtrl; //防止mario於每一層可以按down鍵下降   0可以下降, 1不可以下降
int    iLRCtrl;  //Mario左右圖
int[]    iMonX;  //木箱X
int[]    iMonY;  //木箱Y
int iLife; //生命

/* Methods */
void setup() {
  size(560, 640);
  textFont(loadFont("Ziggurat.vlw"));
  imgBg     = loadImage("stage1.png");
  imgMarioR = loadImage("marior.png");
  imgMarioL = loadImage("mariol.png");
  imgDonkey = loadImage("donkey.png");
  imgMon1   = loadImage("mon1.png")  ;
  fX        = (11);    //Mario出現X
  fY        = (596);   //Mario出現Y
  iLRCtrl   = 0;  //左右
  iMonX = new int[6];
  iMonX[0] = 160;
  iMonX[1] = -460;
  iMonX[2] = -960;
  iMonX[3] = -1460;
  iMonX[4] = -1960;
  iMonX[5] = -2460;
  iMonY = new int[6];
  iMonY[0] = 195;
  iMonY[1] = 195;
  iMonY[2] = 195;
  iMonY[3] = 195;
  iMonY[4] = 195;
  iMonY[5] = 195;
  //iMonX     = 160;  //木箱出現X
  //iMonY[l]     = 195;  //木箱出現Y
  iUpCtrl   = 0;  
  iDownCtrl = 1;
  iLife = 3;
  frameRate(50);  
}

void draw() {
  background(125);
  image(imgBg, (int)0, (int)0);
  
  //mario左右
  if(iLRCtrl == 0) {
    image(imgMarioR, (int)fX, (int)fY);
  } else {
    image(imgMarioL, (int)fX, (int)fY);
  }
  
  image(imgDonkey, (int)50, (int)140);
  for (int k=0; k <= 5; k++) {
    image(imgMon1, (int)iMonX[k], (int)iMonY[k]);
  }
  /* 停留係每一層唔會跌 */
  if(fY==596 && fY>=534) {
    fY = constrain(fY, 0, 596);
  } else if (fY==534 && fY>=460 && fX<522) {
    fY = constrain(fY, 0, 534);
  } else if (fY==460 && fY>=380 && fX>22) {
    fY = constrain(fY, 0, 460);
  } else if (fY==380 && fY>=288 && fX<522) {
    fY = constrain(fY, 0, 380);
  } else if (fY==288 && fY>=200 && fX>22) {
    fY = constrain(fY, 0, 288);
  } else if (fY==200 && fY>=118 && fX<522) {
    fY = constrain(fY, 0, 200);
  } else if (fY==118 && fX<341 && fX>216) {
    fY = constrain(fY, 0, 118);
  } else {      
    /* 上樓梯時唔會跌 */
    if( ((fX>=476 && fX<=491) && (fY<=596 && fY>=534))  ||
        ((fX>=56  && fX<=71 ) && (fY<=534 && fY>=460)) ||
        ((fX>=476 && fX<=491) && (fY<=460 && fY>=380)) ||
        ((fX>=61  && fX<=76 ) && (fY<=380 && fY>=288)) ||
        ((fX>=476 && fX<=491) && (fY<=288 && fY>=200)) ||
        ((fX>=306 && fX<=321) && (fY<=200 && fY>=118))  ) { 
      fY=fY;
    } else {
      fY = fY+2;  // 其他情況會跌 
    }    
  }
  
  /* 可以落樓梯 */
  if( ((fX>=476 && fX<=491) && (fY<594 && fY>=532)) ||
      ((fX>=56  && fX<=71 ) && (fY<532 && fY>=460)) ||
      ((fX>=476 && fX<=491) && (fY<458 && fY>=380)) ||
      ((fX>=61  && fX<=76 ) && (fY<378 && fY>=288)) ||
      ((fX>=476 && fX<=491) && (fY<286 && fY>=200)) ||
      ((fX>=306 && fX<=321) && (fY<198 && fY>=118)) ) { 
    iDownCtrl = 0;
  } else {
    iDownCtrl = 1;
  }

  /* 每一層都給mario跳 */
  if((fY == 596) || 
     (fY == 534 && fX<522) || 
     (fY == 460 && fX>22)  || 
     (fY == 380 && fX<522) || 
     (fY == 288 && fX>22)  || 
     (fY == 200 && fX<522) || 
     (fY == 118 && fX>216 && fX<341) ||
    /* 防止在邊位跌下時可再跳 */
    ((fX>=476 && fX<=491) && (fY<=596 && fY>=534) )||
    ((fX>=56 && fX<=71  ) && (fY<=534 && fY>=460)) ||
    ((fX>=476 && fX<=491) && (fY<=460 && fY>=380)) ||
    ((fX>=61 && fX<=76  ) && (fY<=380 && fY>=288)) ||
    ((fX>=476 && fX<=491) && (fY<=288 && fY>=200)) ||
    ((fX>=306 && fX<=321) && (fY<=200 && fY>=118))) {
    iUpCtrl = 0;
  } else {
    iUpCtrl = 1;
  }
  
  /* mario掂到木箱會跌一層 */
  for (int k=0; k <= 5; k++) {
    if((iMonX[k] >= fX+14 && iMonX[k] <= fX+18 && iMonY[k]>= fY-5 && iMonY[k]<= fY+1) ||
       (iMonX[k] <= fX-28 && iMonX[k] >= fX-32 && iMonY[k]>= fY-5 && iMonY[k]<= fY+1)) {
    iLife = iLife-1;
      if(fY<=596 && fY>=534) {
        fY = 596;
        fX = 11;
      } else if (fY<=534 && fY>=460){
        fY = 534;
      } else if (fY<=460 && fY>=380){
        fY = 460;
      } else if (fY<=380 && fY>=288){
        fY = 380;
      } else if (fY<=288 && fY>=200){
        fY = 288;
      } else if (fY<=200 && fY>=118){
        fY = 200;
      }
    }
  }
  
  // 木箱move
  for(int l=0; l<=5; l++) {
    if(iMonX[l]<530 && iMonY[l]==195) {
      iMonX[l] = iMonX[l] + 5;
    } else if(iMonX[l]==530 && iMonY[l]<285) {
      iMonY[l] = iMonY[l] + 5;
    } else if(iMonX[l]>5 && iMonY[l]==285) {
      iMonX[l] = iMonX[l]- 5;
    }  else if(iMonX[l]==5 && iMonY[l]<375) {
      iMonY[l] = iMonY[l] + 5;
    } else if(iMonX[l]<530 && iMonY[l]==375) {
      iMonX[l] = iMonX[l] + 5;
    } else if(iMonX[l]==530 && iMonY[l]<455) {
      iMonY[l] = iMonY[l] + 5;
    } else if(iMonX[l]>5 && iMonY[l]==455) {
      iMonX[l] = iMonX[l] - 5;
    } else if(iMonX[l]==5 && iMonY[l]<530) {
      iMonY[l] = iMonY[l] + 5;
    } else if(iMonX[l]<530 && iMonY[l]==530) {
      iMonX[l] = iMonX[l] + 5;
    } else if(iMonX[l]==530 && iMonY[l]<595) {
      iMonY[l] = iMonY[l] + 5;
    } else if(iMonX[l]>0 && iMonY[l]==595) {
      iMonX[l] = iMonX[l] - 5;
    } else {
      iMonX[l] = 160;
      iMonY[l] = 195;
    }   
  }
  
  /* 上到頂會贏 */
  if(fY<=120) {
    textSize(30);
    text("You Win!!", 180, 320);
    text("If you want to continue", 80, 360);
    text("Press ''Enter''", 180, 400);
    noLoop();
  } 
  
  /* 顯示生命 */
  if(iLife==3) {
    textSize(14);
    text("Life=3", 0,20);
  } else if (iLife==2) {
    textSize(14);
    text("Life=2", 0, 20);
  } else if (iLife==1) {
    textSize(14);
    text("Life=1", 0, 20);
  } else if (iLife==0) {
    textSize(30);
    text("You Lose!!", 180, 320);
    text("If you want to continue", 80, 360);
    text("Press ''Enter''", 180, 400);
    noLoop();
  }
}

void keyPressed() {
  if (key == CODED) {
    if (keyCode == UP && iUpCtrl == 0 && fY>119) { //fY>119 防止贏或輸之後可以禁到,而令到禁enter唔可以重新開始
      /* 爬樓梯 */
      if( ((fX>=476 && fX<=491) && (fY<=596 && fY>=566)) ||
          ((fX>=56  && fX<=71 ) && (fY<=534 && fY>=462)) ||
          ((fX>=476 && fX<=491) && (fY<=460 && fY>=382)) ||
          ((fX>=61  && fX<=76 ) && (fY<=380 && fY>=290)) ||
          ((fX>=476 && fX<=491) && (fY<=288 && fY>=202)) ||
          ((fX>=306 && fX<=321) && (fY<=200 && fY>=120)) ) { 
        fY = fY-4;      
      } else {
        /*跳*/
        if(fY<=534 && fY>=460) {
          fY = fY-40;
          iUpCtrl = 1;
        } else if(fY<=460 && fY>=380) {
          fY = fY-50;
          iUpCtrl = 1;
        } else if(fY<=380 && fY>=288) {
          fY = fY-50;
          iUpCtrl = 1;
        } else if(fY<=288 && fY>=200) {
          fY = fY-50;
          iUpCtrl = 1;
        } else {
          fY = fY-30; 
          iUpCtrl = 1; 
        } 
      }
    } else if (keyCode == DOWN && iDownCtrl==0  && fY>119){
       fY = fY+2;
    } else if (keyCode == LEFT  && fY>119){
      iLRCtrl = 1;   //mario向左
      fX = fX-2;
      fX = constrain(fX, 0, width-imgMarioR.width);
    } else if (keyCode == RIGHT  && fY>119){
      iLRCtrl = 0;   //mario向右
      fX = fX+2;
      fX = constrain(fX, 0, width-imgMarioR.width);
    } 
  } else if (keyCode == ENTER){
    if((fY<=120) || (iLife==0)) {
      fX = 11;
      fY = 596;
      iMonX[0] = 160;
      iMonX[1] = -460;
      iMonX[2] = -960;
      iMonX[3] = -1460;
      iMonX[4] = -1960;
      iMonX[5] = -2460;
      iMonY[0] = 195;
      iMonY[1] = 195;
      iMonY[2] = 195;
      iMonY[3] = 195;
      iMonY[4] = 195;
      iMonY[5] = 195;
      iLife = 3;
      loop();
    } else {
    }
  } 
 
 /* 
  System.out.println("FX=" + fX + " " + 
                     "FY=" + fY + " " + 
                     "Up=" + iUpCtrl + " " + 
                     "Down=" + iDownCtrl);
 */
}

